

#include <stdio.h>
#include <stdlib.h>
#include "ps7_init.h"
#include "platform.h"
#include "xparameters.h"
#include "xil_printf.h"
#include "xil_io.h"

// Macros
#define CUSTOM_IP_BASEADDR 0x43C00000
#define REGISTER_0_OFFSET 0x00
#define REGISTER_1_OFFSET 0x04
#define REGISTER_2_OFFSET 0x08 //Not in use
#define REGISTER_3_OFFSET 0x0C //Not in use


//Function prototypes
void set_custom_ip_register(int baseaddr, int offset, int value);
int get_custom_ip_register(int baseaddr, int offset);



//MAIN
int main()
{
    init_platform();

    xil_printf("--------Test Project    --------\n\r");
    int r_temp0;
    int r_temp1;
    r_temp1 = get_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_1_OFFSET);

   //set 1 to reset
    set_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_0_OFFSET, 0x80000000);
    for(int i; i < 1000000; i++){}
    r_temp0 = get_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_0_OFFSET);
    for(int i; i < 1000000; i++){}

    // set 0 to reset
    set_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_0_OFFSET, 0x00000000);
    for(int i; i < 1000000; i++){}
    r_temp0 = get_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_0_OFFSET);

    for(int i; i < 1000000; i++){}
    // Set 1 to reset and enable
    set_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_0_OFFSET, 0xC0000000);
    r_temp0 = get_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_0_OFFSET);

    for(int i; i < 1000000; i++){}
    r_temp1 = get_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_1_OFFSET);


    for(int i; i < 1000000; i++){}
    //Read from register spi_to_ps
    r_temp1 = get_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_1_OFFSET);
    xil_printf("slv_reg1 = 0x%02X\n\r", r_temp1);
    set_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_0_OFFSET, 0x80000000);
    r_temp1 = get_custom_ip_register(CUSTOM_IP_BASEADDR, REGISTER_1_OFFSET);
    xil_printf("---slv_reg1 = 0x%02X\n\r", r_temp1);
    xil_printf("---slv_reg1 (18) = 0x%02X\n\r", r_temp1>>18);

    float e;

    //Transform the data to celsius
    e= (r_temp1>>18)* 0.0625;
    printf("TEMPERATUR MÅLER = %.2f °C\n\r",e);

	xil_printf("--------Test Project END--------\n\n\n\r");

    cleanup_platform();
    return 0;
}



// Setting register function
void set_custom_ip_register(int baseaddr, int offset, int value)
{
	Xil_Out32(baseaddr + offset, value);
}
// Reading register function
int get_custom_ip_register(int baseaddr, int offset)
{
	int temp = 0;
	temp = Xil_In32(baseaddr + offset);
	return(temp);
}

